<?php

namespace Drupal\views_kanban\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Drupal\views_kanban\Event\KanbanNodeInsertEvent;

/**
 * Logs the creation of a new node.
 */
class KanbanNodeInsertSubscriber implements EventSubscriberInterface {

  /**
   * Log the creation of a new node.
   *
   * @param \Drupal\views_kanban\Event\KanbanNodeInsertEvent $event
   *   Event.
   */
  public function onKanbanNodeInsert(KanbanNodeInsertEvent $event) {
    $entity = $event->getEntity();
    \Drupal::logger('event_subscriber_kanban')->notice('New @type: @title. Created by: @owner',
      [
        '@type' => $entity->getType(),
        '@title' => $entity->label(),
        '@owner' => $entity->getOwner()->getDisplayName(),
      ]);
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[KanbanNodeInsertEvent::KANBAN_NODE_INSERT][] = ['onKanbanNodeInsert'];
    return $events;
  }

}
